#include "smpeg-player.h"

char** player_get_settings()
{
	static char* retval[8];

	if (!m->mpeg_info.has_video)
	   return NULL;
	retval[0] = strdup("bool\tsmpeg_use_bilinear\tUse Bilinear Filter");
	retval[1] = strdup("bool\tsmpeg_use_hwsurface\tRender directly to Video
			    Memory");
	retval[2] = strdup("string\tsmpeg_vcd_device\tVCD device");
	retval[3] = NULL;
#ifdef USE_GL
	retval[3]=strdup("bool\tsmpeg_use_gl_fs\tUse OpenGL for Fullscreen Renderer");
	retval[4]=strdup("string\tsmpeg_gl_fs_width\tWidth of OpenGL Fullscreen");
	retval[5]=strdup("string\tsmpeg_gl_fs_height\tHeight of OpenGL Fullscreen");
	retval[6]=strdup("bool\tsmpeg_use_gl\tUse OpenGL for all frame rendering");
	retval[7]=NULL;
#endif 
	return(retval);
}

void
set_vcd_device()
{
    if (!(m->vcd_device = loader_get_setting("smpeg_vcd_device")))
       m->vcd_device = g_strdup("/dev/cdrom");
}      



#ifdef USE_GL
void checkgl()
{
	if (loader_get_setting("smpeg_use_gl_fs") && !strcmp("true",loader_get_setting("smpeg_use_gl_fs")))
		m->gl_fullscreen = 1;
	else
		m->gl_fullscreen = 0;
	if (loader_get_setting("smpeg_use_gl") && !strcmp("true",loader_get_setting("smpeg_use_gl"))) {
		m->gl_all = 1;
		m->video_flags = m->video_flags | SDL_OPENGLBLIT;
	}
	else {
		m->gl_all = 0;
		m->video_flags = m->video_flags & ~SDL_OPENGLBLIT;
	}
}
#endif

void check_filter()
{
	SMPEG_Filter * filter;
	if (loader_get_setting("smpeg_use_bilinear") && !strcmp("true",loader_get_setting("smpeg_use_bilinear")))
	{
		filter = SMPEGfilter_bilinear();
		filter = SMPEG_filter(m->mpeg,filter);
		filter->destroy(filter);
		return;
	}
	/* If we are this far, then assume no filtering */
	filter = SMPEGfilter_null();
	filter = SMPEG_filter( m->mpeg, filter);
	filter->destroy(filter);
}

void check_usehard()
{
	if (loader_get_setting("smpeg_use_hwsurface") && !strcmp("true",loader_get_setting("smpeg_use_hwsurface")))
		m->video_flags = (m->video_flags & ~SDL_SWSURFACE) | SDL_HWSURFACE;
	else
		m->video_flags = (m->video_flags & ~SDL_HWSURFACE) | SDL_SWSURFACE;
}



void player_activate_settings()
{
	if (!m->mpeg_info.has_video)
	   return;
	m->doing_settings = 1;
	m->video_flags = SDL_RESIZABLE;
	check_filter();
	check_usehard();
#ifdef USE_GL
	checkgl();
#endif
	setup_screen();
	m->doing_settings = 0;
}
