#include "smpeg-player.h"

void player_double(int val)
{
   m->width = (val ? m->mpeg_info.width*2 : m->mpeg_info.width);
   m->height = (val ? m->mpeg_info.height*2 : m->mpeg_info.height);
   setup_screen();
}

void player_close()
{
   //SDL_RemoveTimer(m->timer_id);
   //m->timer_id = 0;
   //SDL_QuitSubSystem(SDL_INIT_TIMER);
   if (m->mpeg)
   {
      if (SMPEG_status(m->mpeg) == SMPEG_PLAYING)
         SMPEG_stop(m->mpeg);
      SMPEG_delete(m->mpeg);
      m->mpeg=0;
   }
   SDL_QuitSubSystem(SDL_INIT_AUDIO);
   //if (m->screen && m->mpeg_info.has_video) {
      SDL_Quit();
   //}
}

void player_play()
{
   SMPEG_play(m->mpeg);
}

void player_pause()
{
   SMPEG_stop(m->mpeg);
}
   
void player_set_volume(float vol)
{
   SMPEG_setvolume(m->mpeg,(int)vol);
}

float player_get_volume()
{
   return (float)m->volume;
}

float player_get_max_volume()
{
   return 100.0;
}

void player_stop()
{
   SMPEG_stop(m->mpeg);
   SMPEG_rewind(m->mpeg);
   if (m->mpeg_info.has_video) {
     SDL_FillRect (m->screen, NULL, SDL_MapRGB (m->screen->format, 0, 0, 0));
     SDL_UpdateRect (m->screen, 0, 0, 0, 0);
   }
}

void player_loop()
{
   SMPEG_loop(m->mpeg,(m->loop = !(m->loop)));
}

void player_rw()
{
   m->isplaying = (SMPEG_status(m->mpeg) == SMPEG_PLAYING);
   if (m->isplaying) SMPEG_stop(m->mpeg);
   SMPEG_rewind(m->mpeg);
   if (m->mpeg_info.has_video) {
     SDL_FillRect (m->screen, NULL, SDL_MapRGB (m->screen->format, 0, 0, 0));
     SDL_UpdateRect (m->screen, 0, 0, 0, 0);
   }
   if (m->isplaying) SMPEG_play(m->mpeg);
}

void player_ff()
{
   SMPEG_rewind(m->mpeg);
   SMPEG_renderFinal(m->mpeg,m->screen,0,0);
}

void player_seek(float pos)
{
#ifdef VCD_SUPPORT
   if (m->isvcd)
   {
	   vcd_seek((int)pos);
	   return;
   }
#endif
   SMPEG_seek(m->mpeg,(float)pos);
}
