#include "wm_player.h"
void draw(void * data)
{
   if (SDL_SemTryWait(m->Xavail))
	   return;
   // Drop frame if X not avail
#ifdef USE_GL
   if (m->flags & SDL_OPENGL)
   {
	   GLenum error;
	   SDL_Event event;
   	   pthread_mutex_lock(&m->mutex);
	   SDL_LockSurface(m->surface);
   	   if (m->surface && data)
      	      memcpy(m->surface->pixels, data, m->framesize);
   	   SDL_UnlockSurface(m->surface);
   	   pthread_mutex_unlock(&m->mutex);
   	   //SDL_UpdateRect(m->surface,0,0,m->width,m->height);
	   gl_screen_draw( (GLubyte*)m->surface->pixels);
	   error = glGetError();
	   if (error != GL_NO_ERROR) {
		   SDL_SemPost(m->Xavail);
		   return;
	   }
	   SDL_GL_SwapBuffers();
	   SDL_SemPost(m->Xavail);
	   return;
   }
#endif
   pthread_mutex_lock(&m->mutex);
   SDL_LockSurface(m->screen);
   if (m->screen && data)
      memcpy(m->screen->pixels, data, m->framesize);
   SDL_UnlockSurface(m->screen);
   pthread_mutex_unlock(&m->mutex);
   SDL_UpdateRect(m->screen,0,0,m->width,m->height);
   SDL_SemPost(m->Xavail);
}
#ifdef USE_GL
Uint32 resize_check(Uint32 st, void* junk)
{
   SDL_Event event;
   int was;
   if ((SDL_FULLSCREEN & m->flags) || !(SDL_OPENGL & m->flags))
	   return 1; // Return without stealing events!
   if (SDL_PollEvent(&event) && event.type == SDL_VIDEORESIZE) 
   {
	   m->width = event.resize.w;
	   m->height = event.resize.h;
	   setup_screen();
	   //m->screen = SDL_SetVideoMode(event.resize.w,event.resize.h,
	   //		   	        0,m->flags);
	   //gl_screen_resize(event.resize.w,event.resize.h);
   }
}
#endif
