#include "wm_player.h"
	
char** player_get_settings()
{
	static char * retval[6];
	retval[0] = strdup("string\twm_sync_adjust\tSync Adjustment Factor");
	retval[1] = NULL;
#ifdef USE_GL
	retval[1] = strdup("bool\twm_gl_fullscreen\tUse GL for FullScreen");
	retval[2] = strdup("string\twm_gl_fs_width\tWidth of GL Fullscreen");
	retval[3] = strdup("string\twmn_gl_fs_height\tHeight of GL Fullscreen");
	retval[4] = strdup("bool\twm_gl_all\tUse GL for all Video Rendering *UNSTABLE*");
	retval[5] = NULL;
#endif
	return retval;
}

void check_sync_adjust()
{
	char * temp;
	if ((temp = loader_get_setting("wm_sync_adjust"))) {
	   float adj;
	   sscanf(temp,"%f",&adj);
	   m->player->setAsync(adj);
	}
}

#ifdef USE_GL
void check_gl()
{
     if (loader_get_setting("wm_gl_fs") && !strcmp("true",loader_get_setting("wm_gl_fs")))
      	m->gl_fullscreen = 1;
     else
        m->gl_fullscreen = 0;
     if (loader_get_setting("wm_gl_all") && !strcmp("true",loader_get_setting("wm_gl_all"))) {
        m->gl_all = 1;
	m->flags = m->flags | SDL_OPENGL | SDL_RESIZABLE;
     } else {
         m->gl_all = 0;
	 m->flags = m->flags & ~SDL_OPENGL & ~SDL_RESIZABLE;
     }
}
#endif

	
void player_activate_settings()
{
	check_sync_adjust();
#ifdef USE_GL
	check_gl();
#endif
	setup_screen();
}
