/* AVI/ASF plugin for Xtheater, using aviplay library 

   Copyright (C) 2000 Jarrod Johnson

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   Author may be contacted at jbjohns4@eos.ncsu.edu
*/

#include "wm_player.h"

void player_seek(float pos)
{
   m->player->reseek(pos);
}
void player_rw()
{
   if (m->player->isPlaying())
	   player_seek(0);
}

void player_play()
{
   if (!m->player->isPlaying())
	   m->player->start();
   else 
	   m->player->pause(0);
   m->is_playing = 1;
}

void player_pause()
{
   m->is_playing = 0;
   m->player->pause(1);
}

void player_stop()
{
   m->is_playing = 0;
   player_seek(0);
   m->player->pause(1);
   SDL_FillRect (m->screen, NULL, SDL_MapRGB (m->screen->format, 0, 0, 0));
   SDL_UpdateRect (m->screen, 0, 0, 0, 0);
}

float player_get_max_position()
{
   return m->player->GetVideoLength();
}


void player_close()
{
   m->player->endPlayer();
   delete m->player;
   m->player=0;
   SDL_Quit();
}
	
int player_is_playing()
{
	return m->is_playing;
}

float player_get_fps()
{
	return m->player->fps();
}

int player_get_width()
{
   return m->player->width();
}

int player_get_height()
{
   return m->player->height();
}

float player_get_position()
{
   return m->player->GetPos();
}
