#ifndef _WM_PLAYER_H
#undef USE_GL
#define _WM_PLAYER_H
#include <glib.h>
	extern "C" {
#include "../player.h"
};
#include <SDL.h>
#include <pthread.h>
#include <avifile.h>
#include <aviplay.h>
#ifdef USE_GL
#include "glscreen.h"
#endif


typedef struct {
	IAviPlayer*	player;
	int		is_playing;
	SDL_Surface*	screen;
	const SDL_VideoInfo*	vid;
	Uint32		flags;
	int 		depth;
	size_t		framesize;
	int 		width,height;
	char*		error;
	pthread_mutex_t mutex;
	SDL_sem *Xavail;
#ifdef USE_GL
	SDL_Surface* surface;
	int gl_fullscreen;
	int gl_all;
#endif
} wm_data;

extern wm_data *m;

extern "C" {
int player_is_playing();
void player_pause();
void player_play();
void player_activate_settings();
};
void parse_url(char *name);
void setup_screen();
void draw(void * data);
#endif
